function R=fresnel_oblique(e_xx,e_xy,e_yy,e_zz)
% Fresnel reflectance model for alpha degree incidence 
%
% inputs: e_xx,e_xy,e_yy,e_zz - dielectric tensor
%
% returs: R - reflectance

alpha=30;
k_y=sind(alpha);

%make e's be 1x1xv
e_xx=reshape(e_xx,[1 1 size(e_xx,1)]); e_xy=reshape(e_xy, [1 1 size(e_xy,1)]); e_yy=reshape(e_yy, [1 1 size(e_yy,1)]); e_zz=reshape(e_zz, [1 1 size(e_zz,1)]);

%calculate M matrix
k1=-e_zz.*(e_xx+e_yy)+(k_y^2).*(e_yy+e_zz);
k2=-4*((e_xy.^2)+e_yy.*((k_y^2)-e_xx)).*((k_y^2)-e_zz).*e_zz;

gamm1=((-1./(2*e_zz)).*(k1+(k1.^2+k2).^.5)).^.5;
gamm3=((1./(2*e_zz)).*(-k1+(k1.^2+k2).^.5)).^.5;

d_0_inv_2d=[.5 .5/(cosd(alpha)) 0 0; .5 -.5/(cosd(alpha)) 0 0; 0 0 .5/(cosd(alpha)) .5; 0 0 -.5/(cosd(alpha)) .5];
d_0_inv=repmat(d_0_inv_2d, [1 1 size(e_xx,3)]);
zeds=zeros(1,1,size(e_xx,3));
d_1=cat(1, cat(2,e_xy.*(1-(k_y^2)./e_zz),zeds,e_xy.*(1-(k_y^2)./e_zz),zeds), cat(2,gamm1.*e_xy.*(1-(k_y^2)./e_zz),zeds,gamm3.*e_xy.*(1-(k_y^2)./e_zz),zeds), cat(2,(1-(k_y^2)./e_zz).*(gamm1.^2-(e_xx-(k_y^2))),zeds,(1-(k_y^2)./e_zz).*(gamm3.^2-(e_xx-(k_y^2))),zeds), cat(2,gamm1.^3-gamm1.*(e_xx-(k_y^2)),zeds,gamm3.^3-gamm3.*(e_xx-(k_y^2)),zeds));

for i=1:1:size(d_1,3)
    M(:,:,i)=d_0_inv(:,:,i)*d_1(:,:,i);
end

% calculate reflectance coefficients
denom=M(1,1,:).*M(3,3,:)-M(1,3,:).*M(3,1,:);

r_xx=(M(2,1,:).*M(3,3,:)-M(2,3,:).*M(3,1,:))./denom;
r_xx=reshape(r_xx, [size(r_xx,3) 1]);
r_xy=(M(4,1,:).*M(3,3,:)-M(4,3,:).*M(3,1,:))./denom;
r_xy=reshape(r_xy, [size(r_xy,3) 1]);

% calculate reflectance
R=(abs(r_xx)).^2+(abs(r_xy)).^2;

